package com.ruoyi.bst.order.domain;

import com.ruoyi.bst.orderProd.domain.OrderProdVO;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.math.RoundingMode;
import java.util.List;

/**
 * @author wjh
 * 2024/12/16
 */
@Data
public class OrderVO extends Order{

    @ApiModelProperty("产品列表")
    private List<OrderProdVO> prodList;

    @ApiModelProperty("最终产品ID")
    private Long finalProdId;

    @ApiModelProperty("产品总上报数")
    private BigDecimal reportNum;

    @ApiModelProperty("产品有效清点数")
    private BigDecimal storeNum;

    @ApiModelProperty("产品总数")
    private BigDecimal totalNum;

    @ApiModelProperty("成品总上报数")
    private BigDecimal endReportNum;

    @ApiModelProperty("成品有效清点数")
    private BigDecimal endStoreNum;

    @ApiModelProperty("生产进度")
    public BigDecimal getProgress() {
        if (this.storeNum == null || this.getTotalNum() == null) {
            return BigDecimal.ZERO;
        }
        BigDecimal total = this.getTotalNum();
        if (this.getNum() != null) {
            total = total.subtract(this.getNum());
        }
        if (total.compareTo(BigDecimal.ZERO) <= 0) {
            return BigDecimal.ZERO;
        }

        return this.storeNum
                .multiply(new BigDecimal(100))
                .divide(total, 2, RoundingMode.HALF_UP);
    }

    @ApiModelProperty("成品进度")
    public BigDecimal getEndProgress() {
        if (this.endStoreNum == null || this.getNum() == null) {
            return BigDecimal.ZERO;
        }
        return this.endStoreNum
                .multiply(new BigDecimal(100))
                .divide(this.getNum(), 2, RoundingMode.HALF_UP);

    }
}
