package com.ruoyi.bst.orderProd.service;

import com.ruoyi.bst.orderProd.domain.OrderProd;
import com.ruoyi.bst.orderProd.domain.OrderProdQuery;
import com.ruoyi.bst.orderProd.domain.OrderProdVO;

import java.util.List;

/**
 * 订单产品Service接口
 *
 * @author ruoyi
 * @date 2024-12-17
 */
public interface IOrderProdService
{
    /**
     * 查询订单产品
     *
     * @param id 订单产品主键
     * @return 订单产品
     */
    public OrderProdVO selectOrderProdById(Long id);

    /**
     * 查询订单产品列表
     *
     * @param orderProd 订单产品
     * @return 订单产品集合
     */
    public List<OrderProdVO> selectOrderProdList(OrderProdQuery orderProd);

    /**
     * 新增订单产品
     *
     * @param orderProd 订单产品
     * @return 结果
     */
    public int insertOrderProd(OrderProd orderProd);

    /**
     * 修改订单产品
     *
     * @param orderProd 订单产品
     * @return 结果
     */
    public int updateOrderProd(OrderProd orderProd);

    /**
     * 批量删除订单产品
     *
     * @param ids 需要删除的订单产品主键集合
     * @return 结果
     */
    public int deleteOrderProdByIds(Long[] ids);

    /**
     * 删除订单产品信息
     *
     * @param id 订单产品主键
     * @return 结果
     */
    public int deleteOrderProdById(Long id);

    /**
     * 根据订单ID查询
     */
    List<OrderProdVO> selectByOrderId(Long orderId);

    /**
     * 批量插入
     */
    int batchInsert(List<? extends OrderProd> list);

    /**
     * 批量更新
     */
    int batchUpdate(List<? extends OrderProd> list);

    /**
     * 批量删除
     */
    int batchLogicDel(List<? extends OrderProd> list);

    int logicDelByOrderId(Long orderId);

    /**
     * 查询订单产品列表
     *
     * @param query 订单产品列表
     * @return
     */
    List<String> selectNameList(OrderProdQuery query);
}
