package com.ruoyi.bst.prodProcess.mapper;

import com.ruoyi.bst.prodProcess.domain.ProdProcess;
import com.ruoyi.bst.prodProcess.domain.ProdProcessQuery;
import com.ruoyi.bst.prodProcess.domain.ProdProcessVO;
import com.ruoyi.bst.prodProcess.domain.vo.ProdProcessNameVO;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;

/**
 * 产品工序Mapper接口
 *
 * @author ruoyi
 * @date 2024-12-17
 */
public interface ProdProcessMapper
{
    /**
     * 查询产品工序
     *
     * @param id 产品工序主键
     * @return 产品工序
     */
    public ProdProcessVO selectProdProcessById(Long id);

    /**
     * 查询产品工序列表
     *
     * @param query 产品工序
     * @return 产品工序集合
     */
    public List<ProdProcessVO> selectProdProcessList(@Param("query")ProdProcessQuery query);

    /**
     * 新增产品工序
     *
     * @param prodProcess 产品工序
     * @return 结果
     */
    public int insertProdProcess(ProdProcess prodProcess);

    /**
     * 修改产品工序
     *
     * @param prodProcess 产品工序
     * @return 结果
     */
    public int updateProdProcess(@Param("data") ProdProcess prodProcess);

    /**
     * 删除产品工序
     *
     * @param id 产品工序主键
     * @return 结果
     */
    public int deleteProdProcessById(Long id);

    /**
     * 批量删除产品工序
     *
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteProdProcessByIds(Long[] ids);

    int batchInsert(@Param("list") List<? extends ProdProcess> list);

    /**
     * 批量修改产品工序
     */
    int batchUpdate(@Param("list") List<? extends ProdProcess> list);

    /**
     * 逻辑删除
     */
    int logicDel(@Param("ids") List<Long> ids);

    int logicDelByOrderId(Long orderId);

    /**
     * 查询汇总
     */
    public List<Map<String, Object>> selectSum(@Param("query")ProdProcessQuery query, @Param("groupBy")List<String> groupBy);

    /**
     * 查询名称列表
     */
    public List<ProdProcessNameVO> selectProdProcessNames(@Param("query") ProdProcessQuery query);
}
