package com.ruoyi.bst.store.domain;

import com.ruoyi.common.annotation.Excel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

/**
 * @author wjh
 * 2024/12/19
 */
@Data
public class StoreVO extends Store{

    @ApiModelProperty("订单ID")
    private Long orderId;

    @ApiModelProperty("订单编号")
    @Excel(name = "订单编号", type = Excel.Type.EXPORT, sort = 2)
    private String orderNo;

    @ApiModelProperty("产品名称")
    @Excel(name = "产品名称", type = Excel.Type.EXPORT, sort = 3)
    private String prodName;

    @ApiModelProperty("工序名称")
    @Excel(name = "工序名称", type = Excel.Type.EXPORT, sort = 4)
    private String processDeptName;

    @ApiModelProperty("工序部门ID")
    private Long processDeptId;

    @ApiModelProperty("是否最终工序")
    @Excel(name = "是否最终工序", type = Excel.Type.EXPORT, readConverterExp = "false=否,true=是", sort = 5)
    private Boolean processIsEnd;

    @ApiModelProperty("负责工序")
    private String deptProcess;

}
