package com.ruoyi.bst.store.service.impl;

import com.ruoyi.bst.order.domain.enums.OrderStatus;
import com.ruoyi.bst.prodProcess.domain.ProdProcessVO;
import com.ruoyi.bst.prodProcess.service.IProdProcessService;
import com.ruoyi.bst.store.domain.Store;
import com.ruoyi.bst.store.service.StoreValidator;
import com.ruoyi.common.utils.ServiceUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @author wjh
 * 2024/12/21
 */
@Service
public class StoreValidatorImpl implements StoreValidator {

    @Autowired
    private IProdProcessService prodProcessService;

    /**
     * 新增前校验
     *
     * @param data
     */
    @Override
    public void checkBefore(Store data) {
        ServiceUtil.assertion(data == null, "参数错误");

        // 校验工序
        ServiceUtil.assertion(data.getProcessId() == null, "工序不允许为空");
        ProdProcessVO process = prodProcessService.selectProdProcessById(data.getProcessId());
        ServiceUtil.assertion(process == null, "待上报的工序不存在");
        ServiceUtil.assertion(!OrderStatus.canAddStore().contains(process.getOrderStatus()), "当前工序的订单状态不允许上报");

    }
}
