package com.ruoyi.dashboard.prodProcess.service;

import com.alibaba.fastjson2.JSON;
import com.ruoyi.bst.prodProcess.domain.ProdProcessQuery;
import com.ruoyi.bst.prodProcess.mapper.ProdProcessMapper;
import com.ruoyi.dashboard.prodProcess.domain.sum.ProdProcessSumVO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Collections;
import java.util.List;
import java.util.Map;

@Service
public class ProdProcessDashboardService {


    @Autowired
    private ProdProcessMapper prodProcessMapper;

    // 查询数量汇总, 并分组
    public <T> List<T> selectSum(ProdProcessQuery query, List<String> groupBy, Class<T> clazz) {
        List<Map<String, Object>> list = prodProcessMapper.selectSum(query, groupBy);
        if (list.isEmpty()) {
            return Collections.emptyList();
        }
        return JSON.parseArray(JSON.toJSONString(list), clazz);
    }

    // 查询数量汇总
    public ProdProcessSumVO selectSum(ProdProcessQuery query) {
        List<ProdProcessSumVO> list = selectSum(query, null, ProdProcessSumVO.class);
        if (list.isEmpty()) {
            return null;
        }
        return list.get(0);
    }
}
